
From: Paul Mackerras <paulus@samba.org>

On ppc, we emulate instructions that cause alignment exceptions.  If we are
single-stepping an instruction and it causes an alignment exception, we
will currently do the next instruction as well before taking the
single-step exception.  This patch fixes that, so we take the single-step
exception after emulating the instruction.

Signed-off-by: Paul Mackerras <paulus@samba.org>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 25-akpm/arch/ppc/kernel/traps.c |    1 +
 1 files changed, 1 insertion(+)

diff -puN arch/ppc/kernel/traps.c~ppc32-fix-single-stepping-of-emulated-instructions arch/ppc/kernel/traps.c
--- 25/arch/ppc/kernel/traps.c~ppc32-fix-single-stepping-of-emulated-instructions	2005-04-04 18:00:52.000000000 -0700
+++ 25-akpm/arch/ppc/kernel/traps.c	2005-04-04 18:00:52.000000000 -0700
@@ -679,6 +679,7 @@ void AlignmentException(struct pt_regs *
 	fixed = fix_alignment(regs);
 	if (fixed == 1) {
 		regs->nip += 4;	/* skip over emulated instruction */
+		emulate_single_step(regs);
 		return;
 	}
 	if (fixed == -EFAULT) {
_
